
checked = false
mod_plr = {}

FRAME_RATE = 60

-- EASING --
local path = GAMESTATE:GetCurrentSong():GetSongDir()..'lua/'
loadfile(path..'easing.lua')()
loadfile(path..'modhelpers.lua')()
loadfile(path.."mods.lua")()

local function Plr(pn)
	if GAMESTATE:IsPlayerEnabled(pn-1) then
		return SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
	else
		return nil
	end
end
function GetJud(pn)
	return _G['jud'..pn]
end
function GetCom(pn)
	return _G['com'..pn]
end


function mod_do(str,pn)
	if pn then
		if GAMESTATE:IsPlayerEnabled(pn-1) then
			taronuke_mods(str,pn)
		end
	else
		for pn=1,2 do
			if GAMESTATE:IsPlayerEnabled(pn-1) then
				taronuke_mods(str,pn)
			end
		end
	end
end

-- ALIASES --
--These make it so the syntax for the table entries matches the syntax for the nITG template.
--If you want to prefix all your calls with "modhelpers.", "ease.", etc., then you won't need this and can remove this section.
local linear, inQuad, outQuad, inOutQuad, outInQuad, inCubic, outCubic, inOutCubic, outInCubic, inQuart,outQuart, inOutQuart, outInQuart, inQuint, outQuint, inOutQuint, outInQuint, inSine, outSine, inOutSine,outInSine, inExpo, outExpo, inOutExpo, outInExpo, inCirc, outCirc, inOutCirc, outInCirc, inElastic,outElastic, inOutElastic, outInElastic, inBack, outBack, inOutBack, outInBack, inBounce, outBounce,inOutBounce, outInBounce = ease.linear, ease.inQuad, ease.outQuad, ease.inOutQuad, ease.outInQuad,ease.inCubic, ease.outCubic, ease.inOutCubic, ease.outInCubic, ease.inQuart, ease.outQuart,ease.inOutQuart, ease.outInQuart, ease.inQuint, ease.outQuint, ease.inOutQuint, ease.outInQuint,ease.inSine, ease.outSine, ease.inOutSine, ease.outInSine, ease.inExpo, ease.outExpo, ease.inOutExpo,ease.outInExpo, ease.inCirc, ease.outCirc, ease.inOutCirc, ease.outInCirc, ease.inElastic,ease.outElastic, ease.inOutElastic, ease.outInElastic, ease.inBack, ease.outBack, ease.inOutBack,ease.outInBack, ease.inBounce, ease.outBounce, ease.inOutBounce, ease.outInBounce

local perframe, mod_insert, mod2_insert, mod_ease, mod_perframe, mod_message, mod_blacklist, simple_m0d, simple_m0d2, simple_m0d3, mod_wiggle, mod_spring, mod_springt, mod_springt2, mod_spring_adjustable, mod_onebeat, switcfino_add, switcfino_reset, mod_sugarkiller, modulo, reverseRotation, randomXD, mod_bounce, ease_wiggle, ease_wiggleAbs = modhelpers.perframe, modhelpers.mod_insert, modhelpers.mod2_insert, modhelpers.mod_ease, modhelpers.mod_perframe, modhelpers.mod_message, modhelpers.mod_blacklist, modhelpers.simple_m0d, modhelpers.simple_m0d2, modhelpers.simple_m0d3, modhelpers.mod_wiggle, modhelpers.mod_spring, modhelpers.mod_springt, modhelpers.mod_springt2, modhelpers.mod_spring_adjustable, modhelpers.mod_onebeat, modhelpers.switcfino_add, modhelpers.switcfino_reset, modhelpers.mod_sugarkiller, modhelpers.modulo,modhelpers.reverseRotation, modhelpers.randomXD, modhelpers.mod_bounce, modhelpers.ease_wiggle, modhelpers.ease_wiggleAbs

			local m = mod_insert
			local m2 = mod_message
			local me = mod_ease
			local mb = mod_bounce
						
			local l = 'len'
			local e = 'end'
				
			
			
			init_modsp1 = ''
			init_modsp2 = ''
			
			mod_plr = {}
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes
			
			
			local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'), GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
							
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,9999,'*1000 no beat','end'},
			}
						
			--this is both a message broadcaster and a function runner
			--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
			--if you put {beat,function() somecode end}, then function() is run at that beat
			--see example on beat 32
			
			curaction = 1
			--{beat,thing,persists}
			mod_actions = {
			
			
				
			}
						
			--beat-based ease mods
			--{time_start, time_end, mod_start, mod_end, mod, len_or_end, ease_type, player_number, sustaintime, optional_param1, optional_param2}
			--valid ease types are:
				--linear
				--inQuad    outQuad    inOutQuad    outInQuad
				--inCubic   outCubic   inOutCubic   outInCubic
				--inQuart   outQuart   inOutQuart   outInQuart
				--inQuint   outQuint   inOutQuint   outInQuint
				--inSine    outSine    inOutSine    outInSine
				--inExpo    outExpo    inOutExpo    outInExpo
				--inCirc    outCirc    inOutCirc    outInCirc
				--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
				--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
				--inBounce  outBounce  inOutBounce  outInBounce
				
			mods_ease = {
				-- EXAMPLE TWEEN: from beat 0 to 4, make rotationz go from 360 to 0 with the inOutBack tween
				--{0,4,360,0,'rotationz','end',inOutBack},
			}
			
			
			
			mod_perframes = {
				
			}
			
			function mpf(s,e,f)
				table.insert(mod_perframes,{s,e,f})
			end
			
			local h = SCREEN_HEIGHT / 480

			for pn = 1,2 do
				if GAMESTATE:IsPlayerEnabled(pn-1) then
					-- garbage implementation of tweens as mods
					local function rotx(a)
						for pn = 1, 2 do
							local b = Plr(pn)
							if b then
								b:rotationx(a)
							end
						end
					end 
					local function roty(a)
						for pn = 1, 2 do
							local b = Plr(pn)
							if b then
								b:rotationy(a)
							end
						end
					end
					local function rotz(a)
						for pn = 1, 2 do
							local b = Plr(pn)
							if b then
								b:rotationz(a)
							end
						end
					end
					
					me(8.00,0.50,25,0,'Flip',l,outQuad)
					me(8.75,0.50,25,0,'Flip',l,outQuad)
					me(9.50,0.50,25,0,'Flip',l,outQuad)
					me(10.25,0.50,25,0,'Flip',l,outQuad)
					me(11.00,0.50,25,0,'Flip',l,outQuad)
					m(11.50,1,'*10000 No Flip',l)
					
					me(12,1,0,50,'Stealth',l,linear)
					me(12,1,0,75,'Cover',l,linear)
					me(12,1,0,100,'Dark',l,linear)
					me(14,1,50,0,'Stealth',l,linear)
					me(14,1,75,0,'Cover',l,linear)
					me(14,1,100,0,'Dark',l,linear)
					m(15,1,'*10000 No Stealth',l)
					m(15,1,'*10000 No Cover',l)
					m(15,1,'*10000 No Dark',l)
					
					me(20,1,0,50,'Stealth',l,linear)
					me(20,1,0,75,'Cover',l,linear)
					me(20,1,0,100,'Dark',l,linear)
					me(22,1,50,0,'Stealth',l,linear)
					me(22,1,75,0,'Cover',l,linear)
					me(22,1,100,0,'Dark',l,linear)
					m(23,1,'*10000 No Stealth',l)
					m(23,1,'*10000 No Cover',l)
					m(23,1,'*10000 No Dark',l)
					
					me(28,1,0,50,'Stealth',l,linear)
					me(28,1,0,75,'Cover',l,linear)
					me(28,1,0,100,'Dark',l,linear)
					me(30,1,50,0,'Stealth',l,linear)
					me(30,1,75,0,'Cover',l,linear)
					me(30,1,100,0,'Dark',l,linear)
					m(31,1,'*10000 No Stealth',l)
					m(31,1,'*10000 No Cover',l)
					m(31,1,'*10000 No Dark',l)
					
					m(23.5,1,'*10000 1000% Beat',l)
					m(24.5,1,'*10000 No Beat',l)
					m(27.5,1,'*10000 -1000% Beat',l)
					m(28.5,1,'*10000 No Beat',l)
					m(31.5,1,'*10000 1000% Beat',l)
					m(32.5,1,'*10000 No Beat',l)
					m(33.5,1,'*10000 -1000% Beat',l)
					m(34.5,1,'*10000 No Beat',l)
					m(35.5,3,'*10000 1000% Beat',l)
					m(38.5,1,'*10000 No Beat',l)
					
					me(44,1,0,50,'Stealth',l,linear)
					me(44,1,0,75,'Cover',l,linear)
					me(44,1,0,100,'Dark',l,linear)
					me(46,1,50,0,'Stealth',l,linear)
					me(46,1,75,0,'Cover',l,linear)
					me(46,1,100,0,'Dark',l,linear)
					m(47,1,'*10000 No Stealth',l)
					m(47,1,'*10000 No Cover',l)
					m(47,1,'*10000 No Dark',l)
					
					me(52,1,0,50,'Stealth',l,linear)
					me(52,1,0,75,'Cover',l,linear)
					me(52,1,0,100,'Dark',l,linear)
					me(54,1,50,0,'Stealth',l,linear)
					me(54,1,75,0,'Cover',l,linear)
					me(54,1,100,0,'Dark',l,linear)
					m(55,1,'*10000 No Stealth',l)
					m(55,1,'*10000 No Cover',l)
					m(55,1,'*10000 No Dark',l)
					
					me(60,1,0,40,'Stealth',l,linear)
					me(60,1,0,70,'Cover',l,linear)
					me(60,1,0,100,'Dark',l,linear)
					me(62,1,40,0,'Stealth',l,linear)
					me(62,1,70,0,'Cover',l,linear)
					me(62,1,100,0,'Dark',l,linear)
					m(63,1,'*10000 No Stealth',l)
					m(63,1,'*10000 No Cover',l)
					m(63,1,'*10000 No Dark',l)
					
					me(67.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(68.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(68.50,0.25,0,-78,'ConfusionOffset',l,linear)
					me(68.75,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(69.25,0.25,0,78,'ConfusionOffset',l,linear)
					me(69.50,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(70.00,0.25,0,-78,'ConfusionOffset',l,linear)
					me(70.25,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(70.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(71.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					m(71.50,1,'*10000 No ConfusionOffset',l)

					m(71.500,0.125,'*10000 No ConfusionOffset',l)
					m(71.625,0.125,'*10000 157% ConfusionOffset',l)
					m(71.750,0.125,'*10000 314% ConfusionOffset',l)
					m(71.875,0.125,'*10000 471% ConfusionOffset',l)
					m(72.000,1.000,'*10000 No ConfusionOffset',l)
					
					m(119.500,0.125,'*10000 No ConfusionOffset',l)
					m(119.625,0.125,'*10000 314% ConfusionOffset',l)
					m(119.750,0.125,'*10000 157% ConfusionOffset',l)
					m(119.875,0.125,'*10000 471% ConfusionOffset',l)
					m(120.000,1.000,'*10000 No ConfusionOffset',l)
					
					me(163.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(164.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(164.50,0.25,0,-78,'ConfusionOffset',l,linear)
					me(164.75,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(165.25,0.25,0,78,'ConfusionOffset',l,linear)
					me(165.50,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(166.00,0.25,0,-78,'ConfusionOffset',l,linear)
					me(166.25,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(166.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(167.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					m(167.50,1,'*10000 No ConfusionOffset',l)
					
					m(183.000,0.125,'*10000 No ConfusionOffset',l)
					m(183.125,0.125,'*10000 417% ConfusionOffset',l)
					m(183.250,0.125,'*10000 314% ConfusionOffset',l)
					m(183.375,0.125,'*10000 157% ConfusionOffset',l)
					m(183.500,0.125,'*10000 No ConfusionOffset',l)
					m(183.625,0.125,'*10000 417% ConfusionOffset',l)
					m(183.750,0.125,'*10000 157% ConfusionOffset',l)
					m(183.875,0.125,'*10000 314% ConfusionOffset',l)
					m(184.000,1.000,'*10000 No ConfusionOffset',l)
					
					me(192,8,0,100,'Cover',l,inQuad)
					me(196,4,0,100,'Dark',l,inQuad)
					me(199,2,0,100,'Stealth',l,linear)
					me(200,1,0,800,'Centered',l,linear)
					m(200,1,'*10000 Dark',l)
					m(200,1,'*10000 Cover',l)
					
					me(201,30,2000,0,'Bumpy',l,linear)
					-- me(201,30,25,0,'Flip',l,linear)
					me(201,30,-300,0,'Centered',l,outQuad)
					-- use rotx instead of Hallway/Distant so not to break for the like 3 people use use Hallway/Distant
					-- thanks for making me do this :V
					me(201,55,-90,0,rotx,l,outQuad)
					-- TODO: Figure out how to restore the player's mini value
					-- me(201,55,200,0,'Mini',l,outCubic)
					-- WAIT SUBMISSION IS DUE -TOMORROW-
					-- WELL I GUESS WE HAVE THE HALF-ASSED VERSION THAT STILL LOOKS DECENT
					me(201,55,100,0,'Dark',l,inQuad)
					me(201,55,100,0,'Stealth',l,linear)
					m(232,1,'*10000 No Bumpy',l)
					m(232,1,'*10000 No Centered',l)
					
					me(256,4,100,0,'Dark',l,linear)
					me(256,4,50,0,'Stealth',l,linear)
					me(256,2,360,0,roty,l,outQuad)
					
					me(268,1,0,60,'Stealth',l,linear)
					me(268,1,0,80,'Cover',l,linear)
					me(268,1,0,100,'Dark',l,linear)
					me(270,1,60,0,'Stealth',l,linear)
					me(270,1,80,0,'Cover',l,linear)
					me(270,1,100,0,'Dark',l,linear)
					m(271,1,'*10000 No Stealth',l)
					m(271,1,'*10000 No Cover',l)
					m(271,1,'*10000 No Dark',l)
					
					me(276,1,0,20,'Stealth',l,linear)
					me(276,1,0,60,'Cover',l,linear)
					me(276,1,0,100,'Dark',l,linear)
					me(278,1,20,0,'Stealth',l,linear)
					me(278,1,60,0,'Cover',l,linear)
					me(278,1,100,0,'Dark',l,linear)
					m(279,1,'*10000 No Stealth',l)
					m(279,1,'*10000 No Cover',l)
					m(279,1,'*10000 No Dark',l)
					
					me(284,1,0,70,'Stealth',l,linear)
					me(284,1,0,85,'Cover',l,linear)
					me(284,1,0,100,'Dark',l,linear)
					me(286,1,70,0,'Stealth',l,linear)
					me(286,1,85,0,'Cover',l,linear)
					me(286,1,100,0,'Dark',l,linear)
					m(287,1,'*10000 No Stealth',l)
					m(287,1,'*10000 No Cover',l)
					m(287,1,'*10000 No Dark',l)
					
					me(292,1,0,20,'Stealth',l,linear)
					me(292,1,0,50,'Cover',l,linear)
					me(292,1,0,80,'Dark',l,linear)
					me(294,1,20,0,'Stealth',l,linear)
					me(294,1,50,0,'Cover',l,linear)
					me(294,1,80,0,'Dark',l,linear)
					m(295,1,'*10000 No Stealth',l)
					m(295,1,'*10000 No Cover',l)
					m(295,1,'*10000 No Dark',l)
					
					me(296,2,80,0,'Stealth',l,linear)
					me(296,2,100,0,'Dark',l,linear)
					me(296,32,100,0,'Cover',l,linear)
					me(296,32,0,160,'Beat',l,linear)
					me(328,2,50,0,'Stealth',l,linear)
					m(327.5,1,'*10000 1000% Beat',l)
					m(328.5,1,'*10000 No Beat',l)
					
					me(335.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(336.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(336.50,0.25,0,-78,'ConfusionOffset',l,linear)
					me(336.75,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(337.25,0.25,0,78,'ConfusionOffset',l,linear)
					me(337.50,0.50,78,0,'ConfusionOffset',l,outQuad)
					me(338.00,0.25,0,-78,'ConfusionOffset',l,linear)
					me(338.25,0.50,-78,0,'ConfusionOffset',l,outQuad)
					me(338.75,0.25,0,78,'ConfusionOffset',l,linear)
					me(339.00,0.50,78,0,'ConfusionOffset',l,outQuad)
					m(339.50,1,'*10000 No ConfusionOffset',l)
					
					m(342.000,0.125,'*10000 No ConfusionOffset',l)
					m(342.125,0.125,'*10000 157% ConfusionOffset',l)
					m(342.250,0.125,'*10000 471% ConfusionOffset',l)
					m(342.375,0.125,'*10000 157% ConfusionOffset',l)
					m(342.500,0.125,'*10000 No ConfusionOffset',l)
					m(342.625,0.125,'*10000 314% ConfusionOffset',l)
					m(342.750,0.125,'*10000 471% ConfusionOffset',l)
					m(342.875,0.125,'*10000 314% ConfusionOffset',l)
					m(343.000,0.125,'*10000 No ConfusionOffset',l)
					m(343.125,0.125,'*10000 157% ConfusionOffset',l)
					m(343.250,0.125,'*10000 471% ConfusionOffset',l)
					m(343.375,0.125,'*10000 314% ConfusionOffset',l)
					m(343.500,0.5,'*10000 No ConfusionOffset',l)
					
					me(344,4,100,0,'Dark',l,linear)
					me(344,4,50,0,'Stealth',l,linear)
					me(344,4,720,0,rotz,l,outQuad)
					
					me(348,1,0,80,'Stealth',l,linear)
					me(348,1,0,90,'Cover',l,linear)
					me(348,1,0,100,'Dark',l,linear)
					me(351,1,80,0,'Stealth',l,linear)
					me(351,1,90,0,'Cover',l,linear)
					me(351,1,100,0,'Dark',l,linear)
					m(352,1,'*10000 No Stealth',l)
					m(352,1,'*10000 No Cover',l)
					m(352,1,'*10000 No Dark',l)
					
					me(352,412,0,30,'Wave',e,linear)
					me(352,412,0,45,'Stealth',e,linear)
					me(352,381,0,29,'Bumpy',e,linear)
					me(352,381,0,-29,'Drunk',e,linear)
					me(381,382,29,0,'Bumpy',e,linear)
					me(381,382,-29,0,'Drunk',e,linear)
					me(352,381,0,-29,'Beat',e,linear)
					m(380.5,383.5,'*10000 No Beat',e)
					m(384,412,'*10000 30% Beat',e)
					me(384,412,0,42,'Drunk',e,linear)
					me(384,412,0,28,'Bumpy',e,linear)
					me(412,1,30,0,'Beat',l,linear)
					me(412,2,30,0,'Wave',l,linear)
					me(412,2,42,0,'Bumpy',l,linear)
					me(412,2,28,0,'Drunk',l,linear)
					me(412,4,45,0,'Stealth',l,linear)
					me(416,0.5,1000,0,'Beat',l,linear)
					me(416,2,50,0,'Stealth',l,linear)
					m(416.5,1,'*10000 No Beat',l)
					m(418,1,'*10000 No Stealth',l)
					
					m(411.500,0.125,'*10000 No ConfusionOffset',l)
					m(411.625,0.125,'*10000 157% ConfusionOffset',l)
					m(411.750,0.125,'*10000 314% ConfusionOffset',l)
					m(411.875,0.125,'*10000 471% ConfusionOffset',l)
					m(412.000,1.000,'*10000 No ConfusionOffset',l)
					
					me(468,8,0,100,'Cover',l,linear)
					me(476,4,0,100,'Dark',l,linear)
					me(480,16,0,1100,'Bumpy',l,outQuint)
					me(480,16,0,550,'Drunk',l,outQuart)
					me(480,16,0,550,'Tornado',l,outQuart)
					me(480,16,0,275,'Distant',l,outCubic)
					me(480,16,0,-275,'Centered',l,outCubic)
					me(480,16,36,100,'Stealth',l,linear)
					m(480,32,'*10000 No Reverse',l) --It's a visual effect at the end, it doesn't matter if it bricks reverse
				end
			end
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end

local ac = Def.ActorFrame{
	Name= "xtl_actor_d",
	Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat() s:sleep(9e9) end },
	Def.Actor{ InitCommand= function(s) my_auxvar = s end,
	},
	Def.Actor{
		
		OnCommand=function(s)
			s:queuecommand('Update')
		end,
		UpdateCommand=function(self)
			
			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment')
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo')
					end
					
				end
				
				screen = SCREENMAN:GetTopScreen()
				checked = true --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				for i=1,2 do
					--mod_do('clearall',i)
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				for i,v in pairs(mods) do
					if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
						if beat >=v[1] then
							if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
								if table.getn(v) == 5 then
									mod_do(v[3],v[5])
								else
									mod_do(v[3])
								end
							end
						end
					else
						v[1] = 0
						v[2] = 0
						v[3] = ''
						v[4] = 'error'
						SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')')
					end
				end
				
				--------------------------------------------------------------------------------------
				-- i dont know who this reader is but he looks like he is made out of EASE HAHAHAHA --
				-- original code by exschwasion, bastardized by taro for cmod support and less 'if' --
				--------------------------------------------------------------------------------------
				for i,v in pairs(mods_ease) do
					if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
						if beat >=v[1] then
							if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
								
								local duration = v[2]
								if v[6] == 'end' then duration = v[2] - v[1] end
								local curtime = beat - v[1]
								local diff = v[4] - v[3]
								local startstrength = v[3]
								local curve = v[7]
								local mod = v[5]
								
								local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
								
								if type(mod) == 'function' then
									mod(strength)
								else
									local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
									mod_do('*10000 '..modstr,v[8]);
								end
								
							elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
							
								local strength = v[4]
								if type(mod) == 'function' then
									mod(strength)
								else
									local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
									mod_do('*10000 '..modstr,v[8]);
								end
								
							end
						end
					else
						SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')')
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				----------------------------------------
				-- HBLBHCBLBJGBHL DO THIS EVERY FRAME --
				----------------------------------------
				
				if table.getn(mod_perframes)>0 then
					for i=1,table.getn(mod_perframes) do
						local a = mod_perframes[i]
						if beat > a[1] and beat < a[2] then
							a[3](beat)
						end
					end
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2])
						end
					end
					curaction = curaction+1
				end
				
			end
			
			self:sleep(1/FRAME_RATE)
			self:queuecommand('Update')

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
	
	}
}

return ac